<template>
<section>
    <div class="container" id="Cartas">
        <div class="row">
            <div class="shadow col-12 mt-4 p-3 mb-5 bg-white rounded">
                <div class="float-left">
                    <a href="javascript:window.history.go(-1);"><i class="material-icons">arrow_back_ios</i> Regresar</a>
                </div>
                <h2 class="text-center">Divisiones Académicas y Carreras</h2>
            </div>
        </div>
        <div class="float-left col-md-6">
            <div class="card text-center">
                <div class="card-header">
                    <h4><strong>Divisiones académicas</strong></h4>
                </div>
                <div class="card-body">
                    <!-- alerta por si no existen -->
                    <div class="row shadow" style="border-radius: 5px">
                        <div v-if="divisiones.length === 0">
                            <div class="alert alert-danger" role="alert" v-if="divisiones.length === 0">
                                <h2 class="lead">No se cuenta con divisiones registradas</h2>
                            </div>
                        </div>
                    </div>
                    <!-- fin de alerta -->
                    <!-- Inicio tabla -->
                    <div class="float-left">
                        <b-button class="mb-1" variant="info" @click="showModal('modal-division')" v-b-tooltip.hover title="Agregar registro"><i class="material-icons">add_box</i></b-button>
                    </div>
                    <br>
                    <table v-show="divisiones.length > 0" class="table table-hover ">
                        <thead>
                            <tr style="background-color: #019979">
                                <!-- <th scope="col">#</th> -->
                                <!-- <th scope="col">nOM</th> -->
                                <th scope="col" class="text-white lead">NOMBRE DIVISIÓN</th>
                                <th scope="col" class="text-white lead">ACCIÓN</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="(division,index) in divisiones" :key="index" class="table-light lead">
                                <!-- <th scope="row">{{carrera.id}}</th>( -->
                                <td>{{division.nombreDivicion}}</td>
                                <!-- <td>{{carrera.nombreCarrera}}</td> -->
                                <td>
                                    <b-button variant="warning" style="margin-right:20px;" id="show-btn" @click="showModal('modal-modificarD'); llenarObjDivision(division)" v-b-tooltip.hover title="Modificar información"><i class="material-icons">create</i></b-button>
                                    <b-button variant="danger" id="show-btn" @click="eliminarDivision(division.id)" v-b-tooltip.hover title="Eliminar registro"><i class="material-icons">delete</i></b-button>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <!-- fin tabla -->
                </div>

            </div>
        </div>
        <div class="float-right col-md-6">
            <div class="card text-center">
                <div class="card-header">
                    <h4><strong>Carreras</strong></h4>
                </div>

                <div class="card-body">
                    <!-- alerta por si no existen -->
                    <div class="row shadow" style="border-radius: 5px">
                        <div v-if="carreras.length === 0">
                            <div class="alert alert-danger" role="alert" v-if="carreras.length === 0">
                                <h2 class="lead">No se cuenta con divisiones registradas</h2>
                            </div>
                        </div>
                    </div>
                    <!-- fin de alerta -->
                    <!-- Inicio tabla -->
                    <div class="float-left">
                        <b-button class="mb-1" variant="info" @click="showModal('modal-ccarrera')" v-b-tooltip.hover title="Agregar registro"><i class="material-icons">add_box</i></b-button>
                    </div>
                    <br>
                    <table v-show="carreras.length > 0" class="table table-hover ">
                        <thead>
                            <tr style="background-color: #019979">
                                <!-- <th scope="col">#</th> -->
                                <!-- <th scope="col">nOM</th> -->
                                <th scope="col" class="text-white lead">NOMBRE CARRERA</th>
                                <th scope="col" class="text-white lead">ACRÓNIMO</th>
                                <th scope="col" class="text-white lead">ACCIÓN</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="(carrera,index) in carreras" :key="index" class="table-light lead">
                                <!-- <th scope="row">{{carrera.id}}</th>( -->
                                <td>{{carrera.nombreCarrera}}</td>
                                <td>{{carrera.acronimoCarrera}}</td>
                                <!-- <td>{{carrera.nombreCarrera}}</td> -->
                                <td>
                                    <b-button variant="warning" style="margin-right:20px;" id="show-btn" @click="showModal('modal-modificar'); llenarObjCarrera(carrera)" v-b-tooltip.hover title="Modificar información"><i class="material-icons">create</i></b-button>
                                    <b-button variant="danger" id="show-btn" @click="eliminarCarrera(carrera.id)" v-b-tooltip.hover title="Eliminar registro"><i class="material-icons">delete</i></b-button>                               
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <!-- fin tabla -->
                </div>
            </div>
        </div>
    </div>
    <div class="container">
        <div class="float-right col-12">
            <div class="card text-center">
                <div class="card-header">
                    <h4><strong>Asignación de Carrreras a Divisiones</strong></h4>
                </div>
                <div class="card-body">
                    <!-- alerta por si no existen -->
                    <div class="row shadow" style="border-radius: 5px">
                        <div v-if="asignaciones.response.lista.length === 0" class="text-center">
                            <div style="margin-left:380px;" class="alert alert-danger" role="alert" v-if="asignaciones.response.lista.length === 0">
                                <h2 class="lead" >No se ha asignado nada aún.</h2>
                            </div>
                        </div>
                    </div>
                    <!-- fin de alerta -->
                    <!-- Inicio tabla -->
                    <div class="float-left">
                        <b-button class="mb-1" variant="info" @click="showModal('modal-asignar')" v-b-tooltip.hover title="Agregar registro"><i class="material-icons">add_box</i></b-button>
                    </div>
                    <table v-show="asignaciones.response.lista.length > 0" class="table table-hover table-light">
                        <thead>
                            <tr style="background-color: #019979">
                                <!-- <th scope="col">#</th> -->
                                <!-- <th scope="col">nOM</th> -->
                                <th scope="col" class="text-white lead">DIVISIÓN</th>
                                <th scope="col" class="text-white lead">CARRERA</th>
                                <th scope="col" class="text-white lead">ACCIÓN</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="(asignacion,index) in asignaciones.response.lista" :key="index" class="table-light lead">
                                <!-- <th scope="row">{{carrera.id}}</th>( -->
                                <td>{{asignacion.nombreDivicion}}</td>
                                <td>{{asignacion.nombreCarrera}}</td>
                                <td>
                                    <b-button variant="warning" style="margin-right:20px;" id="show-btn" @click="showModal('modal-modificarA'); llenarObjAsignacion(asignacion)" v-b-tooltip.hover title="Modificar información"><i class="material-icons">create</i></b-button>
                                    <b-button variant="danger" id="show-btn" @click="eliminarAsignacion(asignacion.id)" v-b-tooltip.hover title="Eliminar registro"><i class="material-icons">delete</i></b-button>                               
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <!-- fin tabla -->
                </div>

            </div>
        </div>
    </div>
<!-- MODAL REGISTRAR CARRERA  -->
    <b-modal ref="modal-ccarrera" hide-footer title="Registrar Carrera">
        <div class="d-block text-left">
            <h3></h3>
            <b-form @submit="registrarCarrera">
                <div class="form-group">
                    <label for="formGroupExampleInput">Nombre carrera</label>
                    <b-form-input type="text" class="form-control" placeholder="Sistemas" v-model="nombreCarrera" :state="carreraValid" required />
                    <b-form-invalid-feedback :state="carreraValid">
                        Ingresa al menos 3 letras.
                    </b-form-invalid-feedback>
                </div>

                <div class="form-group">
                    <label for="formGroupExampleInput2">Acrónimo</label>
                    <b-form-input type="text" class="form-control" placeholder="TIC" v-model="acronimo" :state="acronimValid" required/>
                    <b-form-invalid-feedback :state="acronimValid">
                        Ingresa al menos 3 letras.
                    </b-form-invalid-feedback>
                </div>
                <b-button type="submit" block variant="outline-success">Registrar</b-button>
            </b-form>
        </div>
        <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-ccarrera')">Cancelar</b-button>
    </b-modal>
<!-- MODAL MODIFICAR CARRERA-->
    <b-modal ref="modal-modificar" hide-footer title="Modificar Carrera">
        <div class="d-block text-left">
            <h3></h3>
            <form @submit="modificarCarrera">
                <div class="form-group">
                    <label for="formGroupExampleInput">Nombre carrera</label>
                    <input type="text" class="form-control" placeholder="Example input" v-model="objCarrera.nombreCarrera" required>
                </div>
                <div class="form-group">
                    <label for="formGroupExampleInput2">Acrónimo</label>
                    <input type="text" class="form-control" placeholder="Another input" v-model="objCarrera.acronimoCarrera" required>
                </div>
                <b-button type="submit" block variant="outline-success">Modificar</b-button>
            </form>
        </div>
        <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-modificar')">Cancelar</b-button>
    </b-modal>
<!-- MODAL REGISTRAR DIVISIÓN -->
    <b-modal ref="modal-division" hide-footer title="Registrar División">
        <div class="d-block text-left">
            <h3></h3>
            <b-form @submit="registrarDivision">
                <div class="form-group">
                    <label for="formGroupExampleInput">Nombre división</label>
                    <b-form-input type="text" class="form-control" placeholder="DAMI" v-model="nombreDivicion" :state="diviValid" required/>
                    <b-form-invalid-feedback :state="diviValid">
                        Ingresa al menos 4 letras.
                    </b-form-invalid-feedback>
                </div>
                <b-button type="submit" block variant="outline-success">Registrar</b-button>
            </b-form>
        </div>
        <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-division')">Cancelar</b-button>
    </b-modal>
<!-- MODAL MODIFICAR DIVISIÓN -->
    <b-modal ref="modal-modificarD" hide-footer title="Modificar División">
        <div class="d-block text-left">
            <form @submit="modificarDivision">
                <div class="form-group">
                    <label for="formGroupExampleInput">Nombre división</label>
                    <input type="text" class="form-control" placeholder="Example input" v-model="objDivision.nombreDivicion" required>
                </div>
                <b-button type="submit" block variant="outline-success">Modificar</b-button>
            </form>
        </div>
        <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-modificarD')">Cancelar</b-button>
    </b-modal>

<!-- MODAL ASIGNACIÓN -->
    <b-modal ref="modal-asignar" hide-footer title="Asignación de carreras académicas">
        <div class="d-block text-center">
            <b-form @submit="registrarAsignacion">
                <div class="row form-group">
                    <div class="col">
                        <label for>División Academica</label>
                        <b-form-select v-model="divisionId" class="form-control" required :state="selecDivValid">
                            <option
                                v-for="division in divisiones"
                                :key="division.id"
                                :value="division.id">
                                {{division.nombreDivicion}}
                            </option>
                        </b-form-select>
                        <b-form-invalid-feedback :state="selecDivValid">
                        Seleccione una opcion
                        </b-form-invalid-feedback>
                    </div>
                    <div class="col">
                        <label for>Carrera</label>
                        <b-form-select v-model="carreraId" class="form-control" required :state="selectCarrer">
                            <option v-for="carrera in carreras" :key="carrera.id" :value="carrera.id">
                                {{carrera.nombreCarrera}}
                            </option>
                        </b-form-select>
                        <b-form-invalid-feedback :state="selectCarrer">
                        Seleccione una opcion
                        </b-form-invalid-feedback>
                    </div>
                </div>
                <b-button type="submit" block variant="outline-success"> Registrar</b-button>
            </b-form>
        </div>
        <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-asignar')">Cerrar</b-button>
    </b-modal>
<!-- MODAL MODIFICAR ASIGNACIÓN -->
    <b-modal ref="modal-modificarA" hide-footer title="Modificar Asignación">
        <div class="d-block text-left">
            <form @submit="modificarAsignacion">
                    <div class="row form-group">
                        <div class="col">
                            <label for>División Academica</label>
                            <select v-model="divisionModificarId" class="form-control" required>
                                <option v-for="division in divisiones" :key="division.id" :value="division.id">
                                    {{division.nombreDivicion}}
                                </option>
                            </select>
                    </div>
                    <div class="col">
                            <label for>Carrera</label>
                            <select v-model="carreraModificarId" class="form-control" required>
                                <option v-for="carrera in carreras" :key="carrera.id" :value="carrera.id">
                                    {{carrera.nombreCarrera}}
                                </option>
                            </select>
                    </div>                    
                </div>
                <b-button type="submit" block variant="outline-success"> Modificar</b-button>
            </form>
        </div>
        <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-asignar')">Cancelar</b-button>
    </b-modal>
</section>
</template>

<script>
import axios from "axios";
import {server} from '../../store'
import {functions} from "../../functionsGolbals";
import 'sweetalert2/dist/sweetalert2.min.css';

export default {
    mixins: [functions],
    data() {
        return {
            divisionModificarId: null,
            carreraModificarId: null,
            output: null,
            listas: [],
            carreras: [],
            objCarrera: [],
            nombreCarrera: '',
            acronimo: '',
            divisiones: [],
            objDivision: [],
            nombreDivicion: '',
            divisionId: '',
            carreraId: '',
            asignaciones: [],
            objAsignacon: []
        }
    },
    computed:{
        carreraValid(){
            if(this.nombreCarrera.length == 0)return null;
            if(this.nombreCarrera.length > 2)return true;
            else return false;
        },
        acronimValid(){
            if(this.acronimo.length == 0) return null;
            if(this.acronimo.length > 2)return true;
            else return false;
        },
        diviValid(){
            if(this.nombreDivicion.length == 0)return null;
            if(this.nombreDivicion.length > 3) return true;
            else return false;
        },
        selecDivValid(){
            if(this.divisionId == 0) return null;
            if(this.divisionId > 0)return true;
            else return false;
        },
        selectCarrer(){
            if(this.carreaId == 0)return null;
            if(this.carreaId > 0)return true;
            else return false;
        }

    },
    mounted() {
        if(localStorage.getItem('usuario') == null){
          this.$router.push("/login");
        }
        this.obtenerCarreras();
        this.obenerDivisiones();
        this.obtenerAsignaciones();
    },
    methods: {
        eliminarDivision(id){
            let currentObj = this;
            axios.post(`${server.baseURL}/api/divicion-academica/eliminar`, {
                    divicion: {
                        id: id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obenerDivisiones();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        eliminarCarrera(id){
            let currentObj = this;
            axios.post(`${server.baseURL}/api/carrera/eliminacion`, {
                    carrera: {
                        id: id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerCarreras();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        eliminarAsignacion(id){
            let currentObj = this;
            axios.post(`${server.baseURL}/api/divicion-con-carrera/eliminar`, {
                    eliminar: {
                        id: id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerAsignaciones();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        llenarObjCarrera: function (carrera) {
            this.objCarrera = carrera
        },
        llenarObjAsignacion: function (asignacion) {
            this.objAsignacon = asignacion
        },
        obtenerAsignaciones() {
            axios
                .get(`${server.baseURL}/api/divicion-con-carrera/lista`)
                .then(data => (this.asignaciones = data.data));
        },
        obtenerCarreras() {
            axios
                .get(`${server.baseURL}/api/carrera/lista`)
                .then(data => (this.carreras = data.data));
        },
        registrarCarrera(e) {
            e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/carrera/registro`, {
                    carrera: {
                        nombreCarrera: this.nombreCarrera,
                        acronimoCarrera: this.acronimo,
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerCarreras();
                    currentObj.hideModal('modal-ccarrera');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.obtenerCarreras();
                    currentObj.hideModal('modal-ccarrera');
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        modificarCarrera(e) {
            e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/carrera/modificacion`, {
                    carrera: {
                        id: this.objCarrera.id,
                        nombreCarrera: this.objCarrera.nombreCarrera,
                        acronimoCarrera: this.objCarrera.acronimoCarrera,
                        status: "1"
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerCarreras();
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-modificar');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.hideModal('modal-modificar');
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        llenarObjDivision: function (division) {
            this.objDivision = division
        },
        obenerDivisiones() {
            axios
                .get(`${server.baseURL}/api/divicion-academica/lista`)
                .then(data => (this.divisiones = data.data));
        },
        registrarDivision(e) {
            e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/divicion-academica/registro`, {
                    divicion: {
                        nombreDivicion: this.nombreDivicion,
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obenerDivisiones();
                    currentObj.hideModal('modal-division');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.hideModal('modal-division');
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        modificarDivision(e) {
            e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/divicion-academica/modificacion`, {
                    divicion: {
                        id: this.objDivision.id,
                        nombreDivicion: this.objDivision.nombreDivicion
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obenerDivisiones();
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-modificarD');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.obenerDivisiones();
                    currentObj.hideModal('modal-modificarD');
                    currentObj.alertError(currentObj.output.response.message);

                });
        },
        registrarAsignacion(e) {
            e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/divicion-con-carrera/registrar`, {
                    informacion: {
                        idDivision: this.divisionId,
                        idCarrera: this.carreraId,
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-asignar');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-asignar');
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        modificarAsignacion(e) {
            e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/divicion-con-carrera/modificar`, {
                    modificar: {
                        idDivision: this.divisionModificarId,
                        idCarrera: this.carreraModificarId,
                        id: this.objAsignacon.id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-modificarA');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-modificarA');
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
    }
}
</script>
